#!/usr/bin/perl -w
use strict;
use LWP::UserAgent;

use FindBin qw($Bin);


my $wantlist = "$Bin/wanted.csv";
my %artists;

print "\nprocessing wanted list . ";
open (WANTLIST, "$wantlist") or die "cannot open file $wantlist for reading: $!\n";
foreach (<WANTLIST>){
  if (m:(.*)\t(.*)\t(.*)\n:){
    my $lname = $1;
    my $fname = $2;
    my $album = $3;
    $lname = strip_data($lname);
    $fname = strip_data($fname);
    $album = strip_data($album);
    if (defined $artists{"$lname,$fname"}) {
      push @{$artists{"$lname,$fname"}}, "\n\t$album";
    } else {
      $artists{"$lname,$fname"} = ["\t$album"];
    }
  }
}
close WANTLIST;
  
my $ua= new LWP::UserAgent;
$ua->agent('Mozilla/1.0');
my %available;
print "\nfetching pages . ";

foreach my $letter ('A'..'Z'){
  # First figure out how many pages for this particular letter.  This is needed to prevent
  # retrieving expired pages
  my $max = 1;  
  my $first_page = "http://www.djangomusic.com/treasure_hunt.asp?let=$letter";
  my $response1 = $ua->request(new HTTP::Request 'GET', $first_page);
   if (!$response1->is_success) {warn "Did not succeed in getting $first_page: $!\n"};
   foreach (split ("\n", $response1->content)){
      if (m:let=.&djc=&pdir=o&ppos=\d+\">(\d+)</a> &nbsp;&nbsp;<font size=\"1\" face=\"arial,helvetica\">\(1-100 of:){
        $max = $1;
        last;
      }
    }
    print "\n$letter has $max pages.\n";
  # then check each page for the letter
  foreach my $number (1..$max){
    my $page = "http://www.djangomusic.com/treasure_hunt.asp?let=$letter&djc=&pdir=o&ppos=$number";
    print "checking $number\n";
    my $response2 = $ua->request(new HTTP::Request 'GET', $page);
    if (!$response2->is_success) {warn "Did not succeed in getting $page: $!\n"};
    foreach (split ("\n", $response2->content)){
      s/\[.*\]//;
      if (m:<font size=\"2\" face=\"arial,helvetica\">\d+\. &nbsp; <b><A HREF=\"item_music.asp\?id=(.*)\">(.*)\w*\:\w*(.*)<\/b></a>&nbsp; &nbsp;<font size=\"2\" face=\"arial,helvetica\">(.*)</font>  <font size=\"2\" face=\"arial,helvetica\" color=\"\#cc0000\"><b>Sale (.*)<\/b><\/font><p><\/font>:){
        my $id = $1;
        my ($last_name, $first_name) = split (',', $2);
        my $album = $3;
        my $type = $4;
        my $price = $5;
        $last_name = strip_data($last_name);
        $first_name = strip_data($first_name);
        if ($artists{"$last_name,$first_name"}){
          print "matched artist: $last_name,$first_name\n";
          $album = strip_data($album);
          push  @{$available{"$last_name,$first_name"}}, "\n\n\t$album\t$type\t$price\n";
          push  @{$available{"$last_name,$first_name"}}, "\t     http://www.djangomusic.com/item_music.asp?id='$id\n";
          push  @{$available{"$last_name,$first_name"}}, "\t     $page";
        }
      }
   }
 }
}

# print the whole thing
open (AVAIL, "> $Bin/music_avail.txt") or die "cannot open $Bin/music_avail.txt: !_\n";
print "\nwriting list to $Bin/music_avail.txt\n";
my   @keys = sort keys %available;
foreach my $person ( @keys ) {
     print  "$person:\n@{ $artists{$person} }\n";
     print  "@{ $available{$person} }\n\n";
     print AVAIL "$person:\n@{ $artists{$person} }\n";
     print AVAIL "@{ $available{$person} }\n\n";
     print ". ";
 }
print "\n";
close AVAIL;


sub strip_data {
 my ($string) = @_;
 if (defined $string){
         $string =~ s/^\s+//;
        $string =~ s/\s+$//;  
 } else {
   $string ='';
 }
 return $string;
}
 



